/**
*    GESTIN DE CAMBIOS:
*    -------------------
*    Peticin que motiva el cambio: DGT0302014
*    Descripcin de la peticin: Portal Tributario- Buscador de Oficinas Competentes de Presentacin
*    Fecha de cambio: 16/01/2014
*    Persona que realiza el cambio: Iciar Albillos
*    Observaciones: Se modifica el fichero para migrar a la versin v3 de Google Maps.
*    
*/


// Mtodo que obtiene la geolocalizacin de una ubicacin y situa en el mapa el marcador 
// con sus eventos asociados.
//	@param mapaFieldsetId 	identificador del contenedor de la capa del mapa
//	@param mapaDivId 		identificador de la capa donde est el mapa
//	@param mapa 			google map
//	@param ubicacion 		xml de la ubicacion
//	@param numUbicaciones 	numero total de ubicaciones a situar en el mapa
//	@param rectanguloLocalizaciones 	area que contiene las localizaciones del mapa
//	@param zoom 			nivel visual del mapa
//	@param onclickEnlace	funcion js a la que llamar al hacer click sobre el enlace
//	@param textoEnlace		texto que se mostrar como enlace en el globo informativo
function obtenerLocalizacion(mapaFieldsetId, mapaDivId, mapa, ubicacion, numUbicaciones, rectanguloLocalizaciones, zoom, onclickEnlace, textoEnlace){

	var nombreUbicacion = ubicacion.getAttribute("nombreUbicacion");
	var siglaViaPublica = ubicacion.getAttribute("siglaViaPublica");
	var nombreViaPublica = ubicacion.getAttribute("nombreViaPublica");
	var numeroViaPublica = ubicacion.getAttribute("numeroViaPublica");
	var codigoPostal = ubicacion.getAttribute("codigoPostal");
	var idProvincia = ubicacion.getAttribute("idProvincia");
	var idMunicipio = ubicacion.getAttribute("idMunicipio");
	var provincia = ubicacion.getAttribute("provincia");
	var municipio = ubicacion.getAttribute("municipio");
	var logo = ubicacion.getAttribute("logo");
	    
	var enlace = "";
	
	var localizacion = siglaViaPublica + " " + nombreViaPublica + " " + numeroViaPublica + " " + municipio + " " + provincia;

	//la vecilla se localiza sin nombre de la va por problemas de localizacin de google maps
	if(idProvincia=='24' && idMunicipio=='193'){
		localizacion = municipio+" "+provincia;
	}
	
	var geocoder = new google.maps.Geocoder(); 
	geocoder.geocode({'region': 'ES', 'address': localizacion},	 function(datosRespuesta, estado) {
		    
		if (!datosRespuesta ||  estado != google.maps.GeocoderStatus.OK) {
			if (numUbicaciones==1) {
				ocultarMapa(mapaFieldsetId);
			}
		} else {

			mapa.setCenter(datosRespuesta[0].geometry.location);         
			var marcador = new google.maps.Marker({ map: mapa, position: datosRespuesta[0].geometry.location });
			var infowindow = new google.maps.InfoWindow();
			        	        	
        	google.maps.event.addListener(marcador, 'click', (function(marcador) {
                return function() {
                	  if(tipoBusquedaOk!=null && tipoBusquedaOk=="multiple"){
                	  	enlace = "<br><a href=\"javascript:;\" onclick=\""+onclickEnlace+"('"+idProvincia+"','"+idMunicipio+"');return false;\">"+textoEnlace+"</a>";
                	  	infowindow.setContent(getHtmlInfoLocalizacion(nombreUbicacion,siglaViaPublica,nombreViaPublica,numeroViaPublica,codigoPostal,idProvincia,idMunicipio,provincia,municipio,logo,enlace));
                	  	infowindow.open(mapa, marcador);
                		}
                  
                }
        	})(marcador));
			        	
        	google.maps.event.addListener(marcador, 'mouseover', (function(marcador) {
                return function() {
                	  if(tipoBusquedaOk!=null && tipoBusquedaOk=="multiple"){
                		enlace = "<br><a href=\"javascript:;\" onclick=\""+onclickEnlace+"('"+idProvincia+"','"+idMunicipio+"');return false;\">"+textoEnlace+"</a>"; 
                	  	infowindow.setContent(getHtmlInfoLocalizacion(nombreUbicacion,siglaViaPublica,nombreViaPublica,numeroViaPublica,codigoPostal,idProvincia,idMunicipio,provincia,municipio,logo,enlace));
                	  	infowindow.open(mapa, marcador);
                		}
                  
                }
        	})(marcador));
			        	
			if(numUbicaciones==1){
				infowindow.setContent(getHtmlInfoLocalizacion(nombreUbicacion,siglaViaPublica,nombreViaPublica,numeroViaPublica,codigoPostal,idProvincia,idMunicipio,provincia,municipio,logo,enlace));
				infowindow.open(mapa, marcador);
			}
			        	
			var latitud = datosRespuesta[0].geometry.location.lat();	        	
			var longitud = datosRespuesta[0].geometry.location.lng();	
			
			var punto = new google.maps.LatLng(latitud, longitud); 	        	
			rectanguloLocalizaciones.extend(punto);
			mapa.fitBounds(rectanguloLocalizaciones);
			marcador.setMap(mapa);//es el equivalente a  mapa.addOverlay(marcador);
			mapa.setCenter(rectanguloLocalizaciones.getCenter());
	
		}
	});
	    
	window.onerror = function (){	
		return true;
	}

}
function parseXml(str) {       
	
	if (window.ActiveXObject) {        
		var doc = new ActiveXObject('Microsoft.XMLDOM');         
		doc.loadXML(str);         
		return doc;       
	} else if (window.DOMParser) {         
		return (new DOMParser).parseFromString(str, 'text/xml');       
	}     
}

// Mtodo que situa en el mapa las localizaciones que aparezcan en los resultados de la cn
//	@param mapaFieldsetId 	identificador del contenedor de la capa del mapa
//	@param mapaDivId 		identificador de la capa donde est el mapa
//	@param mapa 			google map
//	@param datos 			xml de localizaciones
//	@param rectanguloLocalizaciones 	area que contiene las localizaciones del mapa
//	@param zoom 			nivel visual del mapa
//	@param onclickEnlace	funcion js a la que llamar al hacer click sobre el enlace
//	@param textoEnlace		texto que se mostrar como enlace en el globo informativo
function addLocalizaciones(mapaFieldsetId, mapaDivId, mapa, datos, rectanguloLocalizaciones, zoom, onclickEnlace, textoEnlace){
	try { 
		var localizaciones = null;
		var xml = parseXml(datos);
		localizaciones = xml.documentElement.getElementsByTagName("ubicacion");
		var i = 0;
		var delay = 100;
		while(i < localizaciones.length) {
			obtenerLocalizacion(mapaFieldsetId, mapaDivId, mapa, localizaciones[i], localizaciones.length, rectanguloLocalizaciones, zoom, onclickEnlace, textoEnlace);
			sleep(delay);
			i++;
		}
	} catch(err) {
		//errores en el parseo del xml o de localizacin de una ubicacin
		ocultarMapa(mapaFieldsetId);

	};
}


// Mtodo que comprueba si Google Maps est disponible: si est disponible se crea el mapa 
// con sus eventos asociados en la capa indicada como parmetro.
//	@param mapaFieldsetId 	identificador del contenedor de la capa del mapa
//	@param mapaDivId 		identificador de la capa donde est el mapa

function iniciarGoogleMap(mapaDivId)
{
	var mapa = new google.maps.Map(document.getElementById(mapaDivId), { zoom: 11,  mapTypeId: google.maps.MapTypeId.ROADMAP });       
	return mapa;	
}


// Mtodo que oculta el mapa de google (independientemente de la conexion)
//	@param mapaFieldsetId 	identificador del contenedor de la capa del mapa

function ocultarMapa(mapaFieldsetId){
    //Eliminamos el fieldset que contiene la capa de los mapas
    var elemento = document.getElementById(mapaFieldsetId);
    elemento.parentNode.removeChild(elemento);
    //Ocultamos la capa solo en caso de mantener el contenedor
    //document.getElementById(mapaDivId).style.display="none";
}


// Mtodo que muestra el mapa de google (si no da problemas de conexin) y las ubicaciones 
// especificadas en el xml de localizaciones.
//	@param mapaFieldsetId 	identificador del contenedor de la capa del mapa
//	@param mapaDivId 		identificador de la capa donde est el mapa
//	@param xmlLocalizaciones 	datos de las ubicaciones a mostrar
//	@param onclickEnlace	funcion js a la que llamar al hacer click sobre el enlace
//	@param textoEnlace		texto que se mostrar como enlace en el globo informativo
function verMapa(mapaFieldsetId, mapaDivId, xmlLocalizaciones, onclickEnlace, textoEnlace){
    try {
        
    	var rectanguloLocalizaciones = new google.maps.LatLngBounds();
        //Inicia la generacion del mapa
        var mapa = iniciarGoogleMap(mapaDivId);
        var zoom = 11;
        if(mapa && (xmlLocalizaciones!='null' && xmlLocalizaciones!="")){
            //Aadir localizacion al mapa
            addLocalizaciones(mapaFieldsetId, mapaDivId, mapa, xmlLocalizaciones, rectanguloLocalizaciones, zoom, onclickEnlace, textoEnlace);
        }
    } catch(err) {
        //si se produce un error de conexin a google
        ocultarMapa(mapaFieldsetId);
        return null;
    };
}


// Funcin que obtiene el html que se muestra como informacin de las ubicaciones
function getHtmlInfoLocalizacion(nombreUbicacion, siglaViaPublica, nombreViaPublica, numeroViaPublica, codigoPostal, idProvincia, idMunicipio, provincia, municipio, logo, enlace){
	var estilo = "font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 11px";
	var textos = "<strong>"+nombreUbicacion+"</strong><br>"+siglaViaPublica+" "+nombreViaPublica+", "+numeroViaPublica+"<br>"+municipio+", "+codigoPostal+"<br>"+provincia;
	var html = "<table><tr><td></td></tr><tr><td><img src='"+rutaImgMenu+"/"+logo+"' align='left'/></td><td align='center' style='"+estilo+"'>"+textos+enlace+"</td></tr></table>";
	return html;
}


// Funcin que pausa las peticiones para que no se sature el servidor google maps
function sleep(millisegundos) {
	var inicio = new Date().getTime();
	while ((new Date().getTime() - inicio) <= millisegundos){}
}
